/* cover-loader.c generated by valac 0.56.17, the Vala compiler
 * generated from cover-loader.vala, do not modify */

/* This file is part of GNOME Games. License: GPL-3.0+.*/

#include "gnome-games.h"
#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>

#define GAMES_COVER_LOADER_COVER_BLUR_RADIUS_FACTOR (30.0 / 128.0)
#define GAMES_COVER_LOADER_SHADOW_FACTOR (20.0 / 128)
#define GAMES_COVER_LOADER_TINY_ICON_SIZE ((guint) 32)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define GAMES_COVER_LOADER_TYPE_COVER_REQUEST (games_cover_loader_cover_request_get_type ())
typedef struct _GamesCoverLoaderCoverRequest GamesCoverLoaderCoverRequest;
enum  {
	GAMES_COVER_LOADER_0_PROPERTY,
	GAMES_COVER_LOADER_NUM_PROPERTIES
};
static GParamSpec* games_cover_loader_properties[GAMES_COVER_LOADER_NUM_PROPERTIES];
#define _g_async_queue_unref0(var) ((var == NULL) ? NULL : (var = (g_async_queue_unref (var), NULL)))
#define _g_thread_unref0(var) ((var == NULL) ? NULL : (var = (g_thread_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block9Data Block9Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _games_cover_loader_cover_request_free0(var) ((var == NULL) ? NULL : (var = (games_cover_loader_cover_request_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _cairo_pattern_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_pattern_destroy (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))

struct _GamesCoverLoaderCoverRequest {
	GamesGame* game;
	gint scale_factor;
	gint cover_size;
	gint icon_size;
	GamesCoverLoaderCoverReadyCallback cb;
	gpointer cb_target;
};

struct _GamesCoverLoaderPrivate {
	GAsyncQueue* request_queue;
	GThread* thread;
};

struct _Block9Data {
	int _ref_count_;
	GamesCoverLoader* self;
	GamesCoverLoaderCoverRequest request;
	gint scale_factor;
	gint cover_size;
	GdkPixbuf* cover_pixbuf;
	gint icon_size;
	GdkPixbuf* icon_pixbuf;
};

static gint GamesCoverLoader_private_offset;
static gpointer games_cover_loader_parent_class = NULL;

static GType games_cover_loader_cover_request_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GamesCoverLoaderCoverRequest* games_cover_loader_cover_request_dup (const GamesCoverLoaderCoverRequest* self);
static void games_cover_loader_cover_request_free (GamesCoverLoaderCoverRequest* self);
static void games_cover_loader_cover_request_copy (const GamesCoverLoaderCoverRequest* self,
                                            GamesCoverLoaderCoverRequest* dest);
static void games_cover_loader_cover_request_destroy (GamesCoverLoaderCoverRequest* self);
static void games_cover_loader_run_callback (GamesCoverLoader* self,
                                      GamesCoverLoaderCoverRequest* request,
                                      gint scale_factor,
                                      gint cover_size,
                                      GdkPixbuf* cover_pixbuf,
                                      gint icon_size,
                                      GdkPixbuf* icon_pixbuf);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static gboolean __lambda18_ (Block9Data* _data9_);
static gboolean ___lambda18__gsource_func (gpointer self);
static GdkPixbuf* games_cover_loader_try_load_cover (GamesCoverLoader* self,
                                              GamesGame* game,
                                              gint size,
                                              gint scale_factor);
static GdkPixbuf* games_cover_loader_load_cache_from_disk (GamesCoverLoader* self,
                                                    GamesGame* game,
                                                    gint size,
                                                    gint scale_factor,
                                                    const gchar* dir);
static GdkPixbuf* games_cover_loader_create_cover_thumbnail (GamesCoverLoader* self,
                                                      GFile* file,
                                                      gint size,
                                                      gint scale_factor);
static void games_cover_loader_save_cache_to_disk (GamesCoverLoader* self,
                                            GamesGame* game,
                                            GdkPixbuf* pixbuf,
                                            gint size,
                                            gint scale_factor,
                                            const gchar* dir_name);
static GdkPixbuf* games_cover_loader_try_load_icon (GamesCoverLoader* self,
                                             GamesGame* game,
                                             gint size,
                                             gint scale_factor);
static void games_cover_loader_run_loader_thread (GamesCoverLoader* self);
static gchar* games_cover_loader_get_cache_path (GamesCoverLoader* self,
                                          GamesGame* game,
                                          gint size,
                                          gint scale_factor,
                                          const gchar* dir_name);
static void games_cover_loader_draw_cover_blur_rect (GamesCoverLoader* self,
                                              cairo_t* cr,
                                              GdkPixbuf* pixbuf,
                                              gint size,
                                              gint scale_factor,
                                              gboolean reverse,
                                              gint x,
                                              gint y,
                                              gint w,
                                              gint h);
static GObject * games_cover_loader_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void _games_cover_loader_cover_request_free0_ (gpointer var);
static gpointer _games_cover_loader_run_loader_thread_gthread_func (gpointer self);
static void games_cover_loader_finalize (GObject * obj);
static GType games_cover_loader_get_type_once (void);

static inline gpointer
games_cover_loader_get_instance_private (GamesCoverLoader* self)
{
	return G_STRUCT_MEMBER_P (self, GamesCoverLoader_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/core/cover-loader.vala"
	return self ? g_object_ref (self) : NULL;
#line 154 "cover-loader.c"
}

static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 26 "../src/core/cover-loader.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 26 "../src/core/cover-loader.vala"
	return _data9_;
#line 164 "cover-loader.c"
}

static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 26 "../src/core/cover-loader.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 174 "cover-loader.c"
		GamesCoverLoader* self;
#line 26 "../src/core/cover-loader.vala"
		self = _data9_->self;
#line 26 "../src/core/cover-loader.vala"
		games_cover_loader_cover_request_destroy (&_data9_->request);
#line 26 "../src/core/cover-loader.vala"
		_g_object_unref0 (_data9_->cover_pixbuf);
#line 26 "../src/core/cover-loader.vala"
		_g_object_unref0 (_data9_->icon_pixbuf);
#line 26 "../src/core/cover-loader.vala"
		_g_object_unref0 (self);
#line 26 "../src/core/cover-loader.vala"
		g_slice_free (Block9Data, _data9_);
#line 188 "cover-loader.c"
	}
}

static gboolean
__lambda18_ (Block9Data* _data9_)
{
	GamesCoverLoader* self;
	GamesCoverLoaderCoverRequest _tmp0_;
	GamesCoverLoaderCoverReadyCallback _tmp1_;
	gpointer _tmp1__target;
	gboolean result;
#line 27 "../src/core/cover-loader.vala"
	self = _data9_->self;
#line 28 "../src/core/cover-loader.vala"
	_tmp0_ = _data9_->request;
#line 28 "../src/core/cover-loader.vala"
	_tmp1_ = _tmp0_.cb;
#line 28 "../src/core/cover-loader.vala"
	_tmp1__target = _tmp0_.cb_target;
#line 28 "../src/core/cover-loader.vala"
	_tmp1_ (_data9_->scale_factor, _data9_->cover_size, _data9_->cover_pixbuf, _data9_->icon_size, _data9_->icon_pixbuf, _tmp1__target);
#line 29 "../src/core/cover-loader.vala"
	result = G_SOURCE_REMOVE;
#line 29 "../src/core/cover-loader.vala"
	return result;
#line 214 "cover-loader.c"
}

static gboolean
___lambda18__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda18_ (self);
#line 27 "../src/core/cover-loader.vala"
	return result;
#line 224 "cover-loader.c"
}

static void
games_cover_loader_run_callback (GamesCoverLoader* self,
                                 GamesCoverLoaderCoverRequest* request,
                                 gint scale_factor,
                                 gint cover_size,
                                 GdkPixbuf* cover_pixbuf,
                                 gint icon_size,
                                 GdkPixbuf* icon_pixbuf)
{
	Block9Data* _data9_;
	GamesCoverLoaderCoverRequest _tmp0_;
	GamesCoverLoaderCoverRequest _tmp1_;
	GamesCoverLoaderCoverRequest _tmp2_ = {0};
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
#line 26 "../src/core/cover-loader.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/core/cover-loader.vala"
	g_return_if_fail (request != NULL);
#line 26 "../src/core/cover-loader.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 26 "../src/core/cover-loader.vala"
	_data9_->_ref_count_ = 1;
#line 26 "../src/core/cover-loader.vala"
	_data9_->self = g_object_ref (self);
#line 26 "../src/core/cover-loader.vala"
	_tmp0_ = *request;
#line 26 "../src/core/cover-loader.vala"
	_tmp1_ = _tmp0_;
#line 26 "../src/core/cover-loader.vala"
	games_cover_loader_cover_request_copy (&_tmp1_, &_tmp2_);
#line 26 "../src/core/cover-loader.vala"
	games_cover_loader_cover_request_destroy (&_data9_->request);
#line 26 "../src/core/cover-loader.vala"
	_data9_->request = _tmp2_;
#line 26 "../src/core/cover-loader.vala"
	_data9_->scale_factor = scale_factor;
#line 26 "../src/core/cover-loader.vala"
	_data9_->cover_size = cover_size;
#line 26 "../src/core/cover-loader.vala"
	_tmp3_ = _g_object_ref0 (cover_pixbuf);
#line 26 "../src/core/cover-loader.vala"
	_g_object_unref0 (_data9_->cover_pixbuf);
#line 26 "../src/core/cover-loader.vala"
	_data9_->cover_pixbuf = _tmp3_;
#line 26 "../src/core/cover-loader.vala"
	_data9_->icon_size = icon_size;
#line 26 "../src/core/cover-loader.vala"
	_tmp4_ = _g_object_ref0 (icon_pixbuf);
#line 26 "../src/core/cover-loader.vala"
	_g_object_unref0 (_data9_->icon_pixbuf);
#line 26 "../src/core/cover-loader.vala"
	_data9_->icon_pixbuf = _tmp4_;
#line 27 "../src/core/cover-loader.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda18__gsource_func, block9_data_ref (_data9_), block9_data_unref);
#line 26 "../src/core/cover-loader.vala"
	block9_data_unref (_data9_);
#line 26 "../src/core/cover-loader.vala"
	_data9_ = NULL;
#line 286 "cover-loader.c"
}

static GdkPixbuf*
games_cover_loader_try_load_cover (GamesCoverLoader* self,
                                   GamesGame* game,
                                   gint size,
                                   gint scale_factor)
{
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GFile* file = NULL;
	GamesCover* _tmp2_;
	GamesCover* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GdkPixbuf* result;
#line 33 "../src/core/cover-loader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/core/cover-loader.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 34 "../src/core/cover-loader.vala"
	_tmp0_ = games_cover_loader_load_cache_from_disk (self, game, size, scale_factor, "covers");
#line 34 "../src/core/cover-loader.vala"
	pixbuf = _tmp0_;
#line 35 "../src/core/cover-loader.vala"
	_tmp1_ = pixbuf;
#line 35 "../src/core/cover-loader.vala"
	if (_tmp1_ != NULL) {
#line 36 "../src/core/cover-loader.vala"
		result = pixbuf;
#line 36 "../src/core/cover-loader.vala"
		return result;
#line 321 "cover-loader.c"
	}
#line 38 "../src/core/cover-loader.vala"
	_tmp2_ = games_game_get_cover (game);
#line 38 "../src/core/cover-loader.vala"
	_tmp3_ = _tmp2_;
#line 38 "../src/core/cover-loader.vala"
	_tmp4_ = games_cover_get_cover (_tmp3_);
#line 38 "../src/core/cover-loader.vala"
	_tmp5_ = _tmp4_;
#line 38 "../src/core/cover-loader.vala"
	_g_object_unref0 (_tmp3_);
#line 38 "../src/core/cover-loader.vala"
	file = _tmp5_;
#line 40 "../src/core/cover-loader.vala"
	_tmp6_ = file;
#line 40 "../src/core/cover-loader.vala"
	if (_tmp6_ != NULL) {
#line 339 "cover-loader.c"
		GFile* _tmp7_;
		GdkPixbuf* _tmp8_;
		GdkPixbuf* _tmp9_;
#line 41 "../src/core/cover-loader.vala"
		_tmp7_ = file;
#line 41 "../src/core/cover-loader.vala"
		_tmp8_ = games_cover_loader_create_cover_thumbnail (self, _tmp7_, size, scale_factor);
#line 41 "../src/core/cover-loader.vala"
		_g_object_unref0 (pixbuf);
#line 41 "../src/core/cover-loader.vala"
		pixbuf = _tmp8_;
#line 42 "../src/core/cover-loader.vala"
		_tmp9_ = pixbuf;
#line 42 "../src/core/cover-loader.vala"
		games_cover_loader_save_cache_to_disk (self, game, _tmp9_, size, scale_factor, "covers");
#line 355 "cover-loader.c"
	}
#line 45 "../src/core/cover-loader.vala"
	result = pixbuf;
#line 45 "../src/core/cover-loader.vala"
	_g_object_unref0 (file);
#line 45 "../src/core/cover-loader.vala"
	return result;
#line 363 "cover-loader.c"
}

static GdkPixbuf*
games_cover_loader_try_load_icon (GamesCoverLoader* self,
                                  GamesGame* game,
                                  gint size,
                                  gint scale_factor)
{
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GIcon* icon = NULL;
	GamesIcon* _tmp2_;
	GamesIcon* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GIcon* _tmp6_;
	GtkIconTheme* theme = NULL;
	GtkIconTheme* _tmp7_;
	GtkIconTheme* _tmp8_;
	GtkIconLookupFlags lookup_flags = 0U;
	GtkIconInfo* icon_info = NULL;
	GtkIconTheme* _tmp9_;
	GIcon* _tmp10_;
	GtkIconInfo* _tmp11_;
	GtkIconInfo* _tmp12_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 48 "../src/core/cover-loader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/core/cover-loader.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 49 "../src/core/cover-loader.vala"
	_tmp0_ = games_cover_loader_load_cache_from_disk (self, game, size, scale_factor, "icons");
#line 49 "../src/core/cover-loader.vala"
	pixbuf = _tmp0_;
#line 50 "../src/core/cover-loader.vala"
	_tmp1_ = pixbuf;
#line 50 "../src/core/cover-loader.vala"
	if (_tmp1_ != NULL) {
#line 51 "../src/core/cover-loader.vala"
		result = pixbuf;
#line 51 "../src/core/cover-loader.vala"
		return result;
#line 408 "cover-loader.c"
	}
#line 53 "../src/core/cover-loader.vala"
	_tmp2_ = games_game_get_icon (game);
#line 53 "../src/core/cover-loader.vala"
	_tmp3_ = _tmp2_;
#line 53 "../src/core/cover-loader.vala"
	_tmp4_ = games_icon_get_icon (_tmp3_);
#line 53 "../src/core/cover-loader.vala"
	_tmp5_ = _tmp4_;
#line 53 "../src/core/cover-loader.vala"
	_g_object_unref0 (_tmp3_);
#line 53 "../src/core/cover-loader.vala"
	icon = _tmp5_;
#line 54 "../src/core/cover-loader.vala"
	_tmp6_ = icon;
#line 54 "../src/core/cover-loader.vala"
	if (_tmp6_ == NULL) {
#line 55 "../src/core/cover-loader.vala"
		result = NULL;
#line 55 "../src/core/cover-loader.vala"
		_g_object_unref0 (icon);
#line 55 "../src/core/cover-loader.vala"
		_g_object_unref0 (pixbuf);
#line 55 "../src/core/cover-loader.vala"
		return result;
#line 434 "cover-loader.c"
	}
#line 57 "../src/core/cover-loader.vala"
	_tmp7_ = gtk_icon_theme_get_default ();
#line 57 "../src/core/cover-loader.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 57 "../src/core/cover-loader.vala"
	theme = _tmp8_;
#line 58 "../src/core/cover-loader.vala"
	lookup_flags = GTK_ICON_LOOKUP_FORCE_SIZE | GTK_ICON_LOOKUP_FORCE_REGULAR;
#line 59 "../src/core/cover-loader.vala"
	_tmp9_ = theme;
#line 59 "../src/core/cover-loader.vala"
	_tmp10_ = icon;
#line 59 "../src/core/cover-loader.vala"
	_tmp11_ = gtk_icon_theme_lookup_by_gicon (_tmp9_, _tmp10_, (gint) size, lookup_flags);
#line 59 "../src/core/cover-loader.vala"
	icon_info = _tmp11_;
#line 61 "../src/core/cover-loader.vala"
	_tmp12_ = icon_info;
#line 61 "../src/core/cover-loader.vala"
	if (_tmp12_ == NULL) {
#line 62 "../src/core/cover-loader.vala"
		result = NULL;
#line 62 "../src/core/cover-loader.vala"
		_g_object_unref0 (icon_info);
#line 62 "../src/core/cover-loader.vala"
		_g_object_unref0 (theme);
#line 62 "../src/core/cover-loader.vala"
		_g_object_unref0 (icon);
#line 62 "../src/core/cover-loader.vala"
		_g_object_unref0 (pixbuf);
#line 62 "../src/core/cover-loader.vala"
		return result;
#line 468 "cover-loader.c"
	}
	{
		gboolean _tmp13_ = FALSE;
		GIcon* _tmp14_;
		GdkPixbuf* _tmp22_;
#line 65 "../src/core/cover-loader.vala"
		_tmp14_ = icon;
#line 65 "../src/core/cover-loader.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, gdk_pixbuf_get_type ())) {
#line 478 "cover-loader.c"
			GIcon* _tmp15_;
#line 65 "../src/core/cover-loader.vala"
			_tmp15_ = icon;
#line 65 "../src/core/cover-loader.vala"
			_tmp13_ = ((guint) gdk_pixbuf_get_width (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gdk_pixbuf_get_type (), GdkPixbuf))) <= GAMES_COVER_LOADER_TINY_ICON_SIZE;
#line 484 "cover-loader.c"
		} else {
#line 65 "../src/core/cover-loader.vala"
			_tmp13_ = FALSE;
#line 488 "cover-loader.c"
		}
#line 65 "../src/core/cover-loader.vala"
		if (_tmp13_) {
#line 492 "cover-loader.c"
			GIcon* _tmp16_;
			GdkPixbuf* _tmp17_;
#line 66 "../src/core/cover-loader.vala"
			_tmp16_ = icon;
#line 66 "../src/core/cover-loader.vala"
			_tmp17_ = gdk_pixbuf_scale_simple (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gdk_pixbuf_get_type (), GdkPixbuf), size * scale_factor, size * scale_factor, GDK_INTERP_NEAREST);
#line 66 "../src/core/cover-loader.vala"
			_g_object_unref0 (pixbuf);
#line 66 "../src/core/cover-loader.vala"
			pixbuf = _tmp17_;
#line 503 "cover-loader.c"
		} else {
			GdkPixbuf* _tmp18_ = NULL;
			GtkIconInfo* _tmp19_;
			GdkPixbuf* _tmp20_;
			GdkPixbuf* _tmp21_;
#line 68 "../src/core/cover-loader.vala"
			_tmp19_ = icon_info;
#line 68 "../src/core/cover-loader.vala"
			_tmp20_ = gtk_icon_info_load_icon (_tmp19_, &_inner_error0_);
#line 68 "../src/core/cover-loader.vala"
			_tmp18_ = _tmp20_;
#line 68 "../src/core/cover-loader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 517 "cover-loader.c"
				goto __catch0_g_error;
			}
#line 68 "../src/core/cover-loader.vala"
			_tmp21_ = _tmp18_;
#line 68 "../src/core/cover-loader.vala"
			_tmp18_ = NULL;
#line 68 "../src/core/cover-loader.vala"
			_g_object_unref0 (pixbuf);
#line 68 "../src/core/cover-loader.vala"
			pixbuf = _tmp21_;
#line 65 "../src/core/cover-loader.vala"
			_g_object_unref0 (_tmp18_);
#line 530 "cover-loader.c"
		}
#line 69 "../src/core/cover-loader.vala"
		_tmp22_ = pixbuf;
#line 69 "../src/core/cover-loader.vala"
		games_cover_loader_save_cache_to_disk (self, game, _tmp22_, size, scale_factor, "icons");
#line 536 "cover-loader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp23_;
		const gchar* _tmp24_;
#line 64 "../src/core/cover-loader.vala"
		e = _inner_error0_;
#line 64 "../src/core/cover-loader.vala"
		_inner_error0_ = NULL;
#line 72 "../src/core/cover-loader.vala"
		_tmp23_ = e;
#line 72 "../src/core/cover-loader.vala"
		_tmp24_ = _tmp23_->message;
#line 72 "../src/core/cover-loader.vala"
		g_critical ("cover-loader.vala:72: Couldn’t load the icon: %s", _tmp24_);
#line 73 "../src/core/cover-loader.vala"
		result = NULL;
#line 73 "../src/core/cover-loader.vala"
		_g_error_free0 (e);
#line 73 "../src/core/cover-loader.vala"
		_g_object_unref0 (icon_info);
#line 73 "../src/core/cover-loader.vala"
		_g_object_unref0 (theme);
#line 73 "../src/core/cover-loader.vala"
		_g_object_unref0 (icon);
#line 73 "../src/core/cover-loader.vala"
		_g_object_unref0 (pixbuf);
#line 73 "../src/core/cover-loader.vala"
		return result;
#line 568 "cover-loader.c"
	}
	__finally0:
#line 64 "../src/core/cover-loader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 64 "../src/core/cover-loader.vala"
		_g_object_unref0 (icon_info);
#line 64 "../src/core/cover-loader.vala"
		_g_object_unref0 (theme);
#line 64 "../src/core/cover-loader.vala"
		_g_object_unref0 (icon);
#line 64 "../src/core/cover-loader.vala"
		_g_object_unref0 (pixbuf);
#line 64 "../src/core/cover-loader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 64 "../src/core/cover-loader.vala"
		g_clear_error (&_inner_error0_);
#line 64 "../src/core/cover-loader.vala"
		return NULL;
#line 587 "cover-loader.c"
	}
#line 76 "../src/core/cover-loader.vala"
	result = pixbuf;
#line 76 "../src/core/cover-loader.vala"
	_g_object_unref0 (icon_info);
#line 76 "../src/core/cover-loader.vala"
	_g_object_unref0 (theme);
#line 76 "../src/core/cover-loader.vala"
	_g_object_unref0 (icon);
#line 76 "../src/core/cover-loader.vala"
	return result;
#line 599 "cover-loader.c"
}

static void
games_cover_loader_run_loader_thread (GamesCoverLoader* self)
{
#line 79 "../src/core/cover-loader.vala"
	g_return_if_fail (self != NULL);
#line 80 "../src/core/cover-loader.vala"
	while (TRUE) {
#line 609 "cover-loader.c"
		GamesCoverLoaderCoverRequest* request = NULL;
		GAsyncQueue* _tmp0_;
		gpointer _tmp1_;
		GamesGame* game = NULL;
		GamesCoverLoaderCoverRequest* _tmp2_;
		GamesGame* _tmp3_;
		GamesGame* _tmp4_;
		gint scale_factor = 0;
		GamesCoverLoaderCoverRequest* _tmp5_;
		gint cover_size = 0;
		GamesCoverLoaderCoverRequest* _tmp6_;
		gint icon_size = 0;
		GamesCoverLoaderCoverRequest* _tmp7_;
		GdkPixbuf* cover_pixbuf = NULL;
		GamesGame* _tmp8_;
		GdkPixbuf* _tmp9_;
		GdkPixbuf* _tmp10_;
		GdkPixbuf* icon_pixbuf = NULL;
		GamesGame* _tmp14_;
		GdkPixbuf* _tmp15_;
		GamesCoverLoaderCoverRequest* _tmp16_;
		GdkPixbuf* _tmp17_;
		GdkPixbuf* _tmp18_;
		GamesCoverLoaderCoverRequest _tmp19_;
#line 81 "../src/core/cover-loader.vala"
		_tmp0_ = self->priv->request_queue;
#line 81 "../src/core/cover-loader.vala"
		_tmp1_ = g_async_queue_pop (_tmp0_);
#line 81 "../src/core/cover-loader.vala"
		request = (GamesCoverLoaderCoverRequest*) _tmp1_;
#line 82 "../src/core/cover-loader.vala"
		_tmp2_ = request;
#line 82 "../src/core/cover-loader.vala"
		_tmp3_ = (*_tmp2_).game;
#line 82 "../src/core/cover-loader.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 82 "../src/core/cover-loader.vala"
		game = _tmp4_;
#line 83 "../src/core/cover-loader.vala"
		_tmp5_ = request;
#line 83 "../src/core/cover-loader.vala"
		scale_factor = (*_tmp5_).scale_factor;
#line 84 "../src/core/cover-loader.vala"
		_tmp6_ = request;
#line 84 "../src/core/cover-loader.vala"
		cover_size = (*_tmp6_).cover_size;
#line 85 "../src/core/cover-loader.vala"
		_tmp7_ = request;
#line 85 "../src/core/cover-loader.vala"
		icon_size = (*_tmp7_).icon_size;
#line 87 "../src/core/cover-loader.vala"
		_tmp8_ = game;
#line 87 "../src/core/cover-loader.vala"
		_tmp9_ = games_cover_loader_try_load_cover (self, _tmp8_, cover_size, scale_factor);
#line 87 "../src/core/cover-loader.vala"
		cover_pixbuf = _tmp9_;
#line 88 "../src/core/cover-loader.vala"
		_tmp10_ = cover_pixbuf;
#line 88 "../src/core/cover-loader.vala"
		if (_tmp10_ != NULL) {
#line 670 "cover-loader.c"
			GamesCoverLoaderCoverRequest* _tmp11_;
			GdkPixbuf* _tmp12_;
			GamesCoverLoaderCoverRequest _tmp13_;
#line 89 "../src/core/cover-loader.vala"
			_tmp11_ = request;
#line 89 "../src/core/cover-loader.vala"
			_tmp12_ = cover_pixbuf;
#line 89 "../src/core/cover-loader.vala"
			_tmp13_ = *_tmp11_;
#line 89 "../src/core/cover-loader.vala"
			games_cover_loader_run_callback (self, &_tmp13_, scale_factor, cover_size, _tmp12_, icon_size, NULL);
#line 682 "cover-loader.c"
		}
#line 91 "../src/core/cover-loader.vala"
		_tmp14_ = game;
#line 91 "../src/core/cover-loader.vala"
		_tmp15_ = games_cover_loader_try_load_icon (self, _tmp14_, icon_size, scale_factor);
#line 91 "../src/core/cover-loader.vala"
		icon_pixbuf = _tmp15_;
#line 93 "../src/core/cover-loader.vala"
		_tmp16_ = request;
#line 93 "../src/core/cover-loader.vala"
		_tmp17_ = cover_pixbuf;
#line 93 "../src/core/cover-loader.vala"
		_tmp18_ = icon_pixbuf;
#line 93 "../src/core/cover-loader.vala"
		_tmp19_ = *_tmp16_;
#line 93 "../src/core/cover-loader.vala"
		games_cover_loader_run_callback (self, &_tmp19_, scale_factor, cover_size, _tmp17_, icon_size, _tmp18_);
#line 80 "../src/core/cover-loader.vala"
		_g_object_unref0 (icon_pixbuf);
#line 80 "../src/core/cover-loader.vala"
		_g_object_unref0 (cover_pixbuf);
#line 80 "../src/core/cover-loader.vala"
		_g_object_unref0 (game);
#line 80 "../src/core/cover-loader.vala"
		_games_cover_loader_cover_request_free0 (request);
#line 708 "cover-loader.c"
	}
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1624 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1625 "glib-2.0.vapi"
	result = self;
#line 1625 "glib-2.0.vapi"
	return result;
#line 722 "cover-loader.c"
}

static gchar*
games_cover_loader_get_cache_path (GamesCoverLoader* self,
                                   GamesGame* game,
                                   gint size,
                                   gint scale_factor,
                                   const gchar* dir_name)
{
	gchar* dir = NULL;
	gchar* _tmp0_;
	GamesUid* uid = NULL;
	GamesUid* _tmp1_;
	GamesUid* _tmp2_;
	GamesUid* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 99 "../src/core/cover-loader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 99 "../src/core/cover-loader.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 99 "../src/core/cover-loader.vala"
	g_return_val_if_fail (dir_name != NULL, NULL);
#line 100 "../src/core/cover-loader.vala"
	_tmp0_ = games_application_get_image_cache_dir (dir_name, size, scale_factor);
#line 100 "../src/core/cover-loader.vala"
	dir = _tmp0_;
#line 102 "../src/core/cover-loader.vala"
	_tmp1_ = games_game_get_uid (game);
#line 102 "../src/core/cover-loader.vala"
	_tmp2_ = _tmp1_;
#line 102 "../src/core/cover-loader.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 102 "../src/core/cover-loader.vala"
	uid = _tmp3_;
#line 104 "../src/core/cover-loader.vala"
	_tmp4_ = string_to_string (dir);
#line 104 "../src/core/cover-loader.vala"
	_tmp5_ = games_uid_to_string (uid);
#line 104 "../src/core/cover-loader.vala"
	_tmp6_ = _tmp5_;
#line 104 "../src/core/cover-loader.vala"
	_tmp7_ = g_strconcat (_tmp4_, "/", _tmp6_, ".png", NULL);
#line 104 "../src/core/cover-loader.vala"
	_tmp8_ = _tmp7_;
#line 104 "../src/core/cover-loader.vala"
	_g_free0 (_tmp6_);
#line 104 "../src/core/cover-loader.vala"
	result = _tmp8_;
#line 104 "../src/core/cover-loader.vala"
	_g_object_unref0 (uid);
#line 104 "../src/core/cover-loader.vala"
	_g_free0 (dir);
#line 104 "../src/core/cover-loader.vala"
	return result;
#line 782 "cover-loader.c"
}

static GdkPixbuf*
games_cover_loader_load_cache_from_disk (GamesCoverLoader* self,
                                         GamesGame* game,
                                         gint size,
                                         gint scale_factor,
                                         const gchar* dir)
{
	gchar* cache_path = NULL;
	gchar* _tmp0_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 107 "../src/core/cover-loader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 107 "../src/core/cover-loader.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 107 "../src/core/cover-loader.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 108 "../src/core/cover-loader.vala"
	_tmp0_ = games_cover_loader_get_cache_path (self, game, size, scale_factor, dir);
#line 108 "../src/core/cover-loader.vala"
	cache_path = _tmp0_;
#line 806 "cover-loader.c"
	{
		GdkPixbuf* _tmp1_ = NULL;
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 111 "../src/core/cover-loader.vala"
		_tmp2_ = gdk_pixbuf_new_from_file (cache_path, &_inner_error0_);
#line 111 "../src/core/cover-loader.vala"
		_tmp1_ = _tmp2_;
#line 111 "../src/core/cover-loader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 817 "cover-loader.c"
			goto __catch0_g_error;
		}
#line 111 "../src/core/cover-loader.vala"
		_tmp3_ = _tmp1_;
#line 111 "../src/core/cover-loader.vala"
		_tmp1_ = NULL;
#line 111 "../src/core/cover-loader.vala"
		result = _tmp3_;
#line 111 "../src/core/cover-loader.vala"
		_g_object_unref0 (_tmp1_);
#line 111 "../src/core/cover-loader.vala"
		_g_free0 (cache_path);
#line 111 "../src/core/cover-loader.vala"
		return result;
#line 832 "cover-loader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 110 "../src/core/cover-loader.vala"
		g_clear_error (&_inner_error0_);
#line 114 "../src/core/cover-loader.vala"
		result = NULL;
#line 114 "../src/core/cover-loader.vala"
		_g_free0 (cache_path);
#line 114 "../src/core/cover-loader.vala"
		return result;
#line 845 "cover-loader.c"
	}
	__finally0:
#line 110 "../src/core/cover-loader.vala"
	_g_free0 (cache_path);
#line 110 "../src/core/cover-loader.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 110 "../src/core/cover-loader.vala"
	g_clear_error (&_inner_error0_);
#line 110 "../src/core/cover-loader.vala"
	return NULL;
#line 856 "cover-loader.c"
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* _tmp0_;
	gchar* result;
#line 3410 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3411 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3411 "glib-2.0.vapi"
	result = _tmp0_;
#line 3411 "glib-2.0.vapi"
	return result;
#line 872 "cover-loader.c"
}

static void
games_cover_loader_save_cache_to_disk (GamesCoverLoader* self,
                                       GamesGame* game,
                                       GdkPixbuf* pixbuf,
                                       gint size,
                                       gint scale_factor,
                                       const gchar* dir_name)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GDateTime* now = NULL;
	GDateTime* _tmp2_;
	gchar* creation_time = NULL;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 118 "../src/core/cover-loader.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/core/cover-loader.vala"
	g_return_if_fail (game != NULL);
#line 118 "../src/core/cover-loader.vala"
	g_return_if_fail (pixbuf != NULL);
#line 118 "../src/core/cover-loader.vala"
	g_return_if_fail (dir_name != NULL);
#line 119 "../src/core/cover-loader.vala"
	_tmp0_ = games_application_get_image_cache_dir (dir_name, size, scale_factor);
#line 119 "../src/core/cover-loader.vala"
	_tmp1_ = _tmp0_;
#line 119 "../src/core/cover-loader.vala"
	games_application_try_make_dir (_tmp1_);
#line 119 "../src/core/cover-loader.vala"
	_g_free0 (_tmp1_);
#line 120 "../src/core/cover-loader.vala"
	_tmp2_ = g_date_time_new_now_local ();
#line 120 "../src/core/cover-loader.vala"
	now = _tmp2_;
#line 121 "../src/core/cover-loader.vala"
	_tmp3_ = g_date_time_to_string (now);
#line 121 "../src/core/cover-loader.vala"
	creation_time = _tmp3_;
#line 914 "cover-loader.c"
	{
		gchar* cover_cache_path = NULL;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 124 "../src/core/cover-loader.vala"
		_tmp4_ = games_cover_loader_get_cache_path (self, game, size, scale_factor, dir_name);
#line 124 "../src/core/cover-loader.vala"
		cover_cache_path = _tmp4_;
#line 125 "../src/core/cover-loader.vala"
		_tmp5_ = string_to_string (creation_time);
#line 125 "../src/core/cover-loader.vala"
		gdk_pixbuf_save (pixbuf, cover_cache_path, "png", &_inner_error0_, "tEXt::Software", "GNOME Games", "tEXt::Creation Time", _tmp5_, NULL, NULL);
#line 125 "../src/core/cover-loader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "../src/core/cover-loader.vala"
			_g_free0 (cover_cache_path);
#line 931 "cover-loader.c"
			goto __catch0_g_error;
		}
#line 123 "../src/core/cover-loader.vala"
		_g_free0 (cover_cache_path);
#line 936 "cover-loader.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 123 "../src/core/cover-loader.vala"
		e = _inner_error0_;
#line 123 "../src/core/cover-loader.vala"
		_inner_error0_ = NULL;
#line 131 "../src/core/cover-loader.vala"
		_tmp6_ = e;
#line 131 "../src/core/cover-loader.vala"
		_tmp7_ = _tmp6_->message;
#line 131 "../src/core/cover-loader.vala"
		g_critical ("cover-loader.vala:131: %s", _tmp7_);
#line 123 "../src/core/cover-loader.vala"
		_g_error_free0 (e);
#line 956 "cover-loader.c"
	}
	__finally0:
#line 123 "../src/core/cover-loader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 123 "../src/core/cover-loader.vala"
		_g_free0 (creation_time);
#line 123 "../src/core/cover-loader.vala"
		_g_date_time_unref0 (now);
#line 123 "../src/core/cover-loader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 123 "../src/core/cover-loader.vala"
		g_clear_error (&_inner_error0_);
#line 123 "../src/core/cover-loader.vala"
		return;
#line 971 "cover-loader.c"
	}
#line 118 "../src/core/cover-loader.vala"
	_g_free0 (creation_time);
#line 118 "../src/core/cover-loader.vala"
	_g_date_time_unref0 (now);
#line 977 "cover-loader.c"
}

static void
games_cover_loader_draw_cover_blur_rect (GamesCoverLoader* self,
                                         cairo_t* cr,
                                         GdkPixbuf* pixbuf,
                                         gint size,
                                         gint scale_factor,
                                         gboolean reverse,
                                         gint x,
                                         gint y,
                                         gint w,
                                         gint h)
{
	gint radius = 0;
	gint shadow_width = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	cairo_pattern_t* gradient = NULL;
	cairo_pattern_t* _tmp3_;
	cairo_pattern_t* _tmp4_;
	cairo_pattern_t* _tmp5_;
	GdkPixbuf* subpixbuf = NULL;
	GdkPixbuf* _tmp6_;
	cairo_surface_t* surface = NULL;
	GdkPixbuf* _tmp7_;
	cairo_surface_t* _tmp8_;
	cairo_surface_t* _tmp9_;
	cairo_surface_t* _tmp10_;
	cairo_pattern_t* _tmp11_;
#line 135 "../src/core/cover-loader.vala"
	g_return_if_fail (self != NULL);
#line 135 "../src/core/cover-loader.vala"
	g_return_if_fail (cr != NULL);
#line 135 "../src/core/cover-loader.vala"
	g_return_if_fail (pixbuf != NULL);
#line 136 "../src/core/cover-loader.vala"
	radius = (gint) (GAMES_COVER_LOADER_COVER_BLUR_RADIUS_FACTOR * size);
#line 137 "../src/core/cover-loader.vala"
	shadow_width = (gint) (GAMES_COVER_LOADER_SHADOW_FACTOR * size);
#line 139 "../src/core/cover-loader.vala"
	if (w == 0) {
#line 139 "../src/core/cover-loader.vala"
		_tmp0_ = TRUE;
#line 1023 "cover-loader.c"
	} else {
#line 139 "../src/core/cover-loader.vala"
		_tmp0_ = h == 0;
#line 1027 "cover-loader.c"
	}
#line 139 "../src/core/cover-loader.vala"
	if (_tmp0_) {
#line 140 "../src/core/cover-loader.vala"
		return;
#line 1033 "cover-loader.c"
	}
#line 143 "../src/core/cover-loader.vala"
	if (h > w) {
#line 143 "../src/core/cover-loader.vala"
		_tmp1_ = -shadow_width;
#line 1039 "cover-loader.c"
	} else {
#line 143 "../src/core/cover-loader.vala"
		_tmp1_ = 0;
#line 1043 "cover-loader.c"
	}
#line 144 "../src/core/cover-loader.vala"
	if (h < w) {
#line 144 "../src/core/cover-loader.vala"
		_tmp2_ = -shadow_width;
#line 1049 "cover-loader.c"
	} else {
#line 144 "../src/core/cover-loader.vala"
		_tmp2_ = 0;
#line 1053 "cover-loader.c"
	}
#line 142 "../src/core/cover-loader.vala"
	_tmp3_ = cairo_pattern_create_linear ((gdouble) 0, (gdouble) 0, (gdouble) _tmp1_, (gdouble) _tmp2_);
#line 142 "../src/core/cover-loader.vala"
	gradient = _tmp3_;
#line 145 "../src/core/cover-loader.vala"
	_tmp4_ = gradient;
#line 145 "../src/core/cover-loader.vala"
	cairo_pattern_add_color_stop_rgba (_tmp4_, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.15);
#line 146 "../src/core/cover-loader.vala"
	_tmp5_ = gradient;
#line 146 "../src/core/cover-loader.vala"
	cairo_pattern_add_color_stop_rgba (_tmp5_, (gdouble) 1, (gdouble) 0, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 148 "../src/core/cover-loader.vala"
	cairo_save (cr);
#line 150 "../src/core/cover-loader.vala"
	cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, (gdouble) w, (gdouble) h);
#line 151 "../src/core/cover-loader.vala"
	cairo_clip (cr);
#line 153 "../src/core/cover-loader.vala"
	_tmp6_ = gdk_pixbuf_new_subpixbuf (pixbuf, x, y, w, h);
#line 153 "../src/core/cover-loader.vala"
	subpixbuf = _tmp6_;
#line 154 "../src/core/cover-loader.vala"
	_tmp7_ = subpixbuf;
#line 154 "../src/core/cover-loader.vala"
	_tmp8_ = gdk_cairo_surface_create_from_pixbuf (_tmp7_, 0, NULL);
#line 154 "../src/core/cover-loader.vala"
	surface = _tmp8_;
#line 155 "../src/core/cover-loader.vala"
	_tmp9_ = surface;
#line 155 "../src/core/cover-loader.vala"
	games_cairo_blur_blur_surface (_tmp9_, (gfloat) radius);
#line 156 "../src/core/cover-loader.vala"
	_tmp10_ = surface;
#line 156 "../src/core/cover-loader.vala"
	cairo_set_source_surface (cr, _tmp10_, (gdouble) 0, (gdouble) 0);
#line 157 "../src/core/cover-loader.vala"
	cairo_paint (cr);
#line 159 "../src/core/cover-loader.vala"
	if (reverse) {
#line 160 "../src/core/cover-loader.vala"
		cairo_rotate (cr, G_PI);
#line 1097 "cover-loader.c"
	} else {
#line 161 "../src/core/cover-loader.vala"
		if (h > w) {
#line 162 "../src/core/cover-loader.vala"
			cairo_translate (cr, (gdouble) w, (gdouble) 0);
#line 1103 "cover-loader.c"
		} else {
#line 164 "../src/core/cover-loader.vala"
			cairo_translate (cr, (gdouble) 0, (gdouble) h);
#line 1107 "cover-loader.c"
		}
	}
#line 166 "../src/core/cover-loader.vala"
	_tmp11_ = gradient;
#line 166 "../src/core/cover-loader.vala"
	cairo_set_source (cr, _tmp11_);
#line 167 "../src/core/cover-loader.vala"
	cairo_paint (cr);
#line 169 "../src/core/cover-loader.vala"
	cairo_rotate (cr, G_PI);
#line 171 "../src/core/cover-loader.vala"
	if (h > w) {
#line 1120 "cover-loader.c"
		gint _tmp12_ = 0;
#line 172 "../src/core/cover-loader.vala"
		if (reverse) {
#line 172 "../src/core/cover-loader.vala"
			_tmp12_ = 0;
#line 1126 "cover-loader.c"
		} else {
#line 172 "../src/core/cover-loader.vala"
			_tmp12_ = -h;
#line 1130 "cover-loader.c"
		}
#line 172 "../src/core/cover-loader.vala"
		cairo_rectangle (cr, (gdouble) 0, (gdouble) _tmp12_, (gdouble) scale_factor, (gdouble) h);
#line 1134 "cover-loader.c"
	} else {
		gint _tmp13_ = 0;
#line 174 "../src/core/cover-loader.vala"
		if (reverse) {
#line 174 "../src/core/cover-loader.vala"
			_tmp13_ = 0;
#line 1141 "cover-loader.c"
		} else {
#line 174 "../src/core/cover-loader.vala"
			_tmp13_ = -w;
#line 1145 "cover-loader.c"
		}
#line 174 "../src/core/cover-loader.vala"
		cairo_rectangle (cr, (gdouble) _tmp13_, (gdouble) 0, (gdouble) w, (gdouble) scale_factor);
#line 1149 "cover-loader.c"
	}
#line 176 "../src/core/cover-loader.vala"
	cairo_set_source_rgba (cr, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.2);
#line 177 "../src/core/cover-loader.vala"
	cairo_fill (cr);
#line 179 "../src/core/cover-loader.vala"
	cairo_set_source_rgba (cr, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.1);
#line 180 "../src/core/cover-loader.vala"
	cairo_paint (cr);
#line 182 "../src/core/cover-loader.vala"
	cairo_restore (cr);
#line 135 "../src/core/cover-loader.vala"
	_cairo_surface_destroy0 (surface);
#line 135 "../src/core/cover-loader.vala"
	_g_object_unref0 (subpixbuf);
#line 135 "../src/core/cover-loader.vala"
	_cairo_pattern_destroy0 (gradient);
#line 1167 "cover-loader.c"
}

static GdkPixbuf*
games_cover_loader_create_cover_thumbnail (GamesCoverLoader* self,
                                           GFile* file,
                                           gint size,
                                           gint scale_factor)
{
	GdkPixbuf* overlay_pixbuf = NULL;
	GdkPixbuf* blur_pixbuf = NULL;
	gint overlay_x = 0;
	gint overlay_y = 0;
	gint width = 0;
	gint height = 0;
	gint zoom_width = 0;
	gint zoom_height = 0;
	gdouble aspect_ratio = 0.0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	cairo_surface_t* image_surface = NULL;
	cairo_surface_t* _tmp12_;
	cairo_t* cr = NULL;
	cairo_surface_t* _tmp13_;
	cairo_t* _tmp14_;
	cairo_t* _tmp29_;
	cairo_t* _tmp42_;
	cairo_t* _tmp43_;
	GdkPixbuf* _tmp44_;
	cairo_t* _tmp45_;
	cairo_surface_t* _tmp46_;
	GdkPixbuf* _tmp47_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 185 "../src/core/cover-loader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 185 "../src/core/cover-loader.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 191 "../src/core/cover-loader.vala"
	_tmp0_ = g_file_get_path (file);
#line 191 "../src/core/cover-loader.vala"
	_tmp1_ = _tmp0_;
#line 191 "../src/core/cover-loader.vala"
	gdk_pixbuf_get_file_info (_tmp1_, &_tmp2_, &_tmp3_);
#line 191 "../src/core/cover-loader.vala"
	width = _tmp2_;
#line 191 "../src/core/cover-loader.vala"
	height = _tmp3_;
#line 191 "../src/core/cover-loader.vala"
	_g_free0 (_tmp1_);
#line 193 "../src/core/cover-loader.vala"
	aspect_ratio = ((gdouble) width) / height;
#line 195 "../src/core/cover-loader.vala"
	if (height >= width) {
#line 196 "../src/core/cover-loader.vala"
		height = size;
#line 197 "../src/core/cover-loader.vala"
		width = (gint) (size * aspect_ratio);
#line 199 "../src/core/cover-loader.vala"
		zoom_width = size;
#line 200 "../src/core/cover-loader.vala"
		zoom_height = (gint) ((size * height) / ((gdouble) width));
#line 202 "../src/core/cover-loader.vala"
		overlay_x = (gint) ((height - width) / 2);
#line 203 "../src/core/cover-loader.vala"
		overlay_y = 0;
#line 1235 "cover-loader.c"
	} else {
#line 206 "../src/core/cover-loader.vala"
		width = size;
#line 207 "../src/core/cover-loader.vala"
		height = (gint) (size / aspect_ratio);
#line 209 "../src/core/cover-loader.vala"
		zoom_height = size;
#line 210 "../src/core/cover-loader.vala"
		zoom_width = (gint) ((size * width) / ((gdouble) height));
#line 212 "../src/core/cover-loader.vala"
		overlay_x = 0;
#line 213 "../src/core/cover-loader.vala"
		overlay_y = (gint) ((width - height) / 2);
#line 1249 "cover-loader.c"
	}
#line 216 "../src/core/cover-loader.vala"
	if (width == height) {
#line 1253 "cover-loader.c"
		{
			GdkPixbuf* _tmp4_ = NULL;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GdkPixbuf* _tmp7_;
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
#line 218 "../src/core/cover-loader.vala"
			_tmp5_ = g_file_get_path (file);
#line 218 "../src/core/cover-loader.vala"
			_tmp6_ = _tmp5_;
#line 218 "../src/core/cover-loader.vala"
			_tmp7_ = gdk_pixbuf_new_from_file_at_scale (_tmp6_, width, height, FALSE, &_inner_error0_);
#line 218 "../src/core/cover-loader.vala"
			_tmp8_ = _tmp7_;
#line 218 "../src/core/cover-loader.vala"
			_g_free0 (_tmp6_);
#line 218 "../src/core/cover-loader.vala"
			_tmp4_ = _tmp8_;
#line 218 "../src/core/cover-loader.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1275 "cover-loader.c"
				goto __catch0_g_error;
			}
#line 218 "../src/core/cover-loader.vala"
			_tmp9_ = _tmp4_;
#line 218 "../src/core/cover-loader.vala"
			_tmp4_ = NULL;
#line 218 "../src/core/cover-loader.vala"
			result = _tmp9_;
#line 218 "../src/core/cover-loader.vala"
			_g_object_unref0 (_tmp4_);
#line 218 "../src/core/cover-loader.vala"
			_g_object_unref0 (blur_pixbuf);
#line 218 "../src/core/cover-loader.vala"
			_g_object_unref0 (overlay_pixbuf);
#line 218 "../src/core/cover-loader.vala"
			return result;
#line 1292 "cover-loader.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp10_;
			const gchar* _tmp11_;
#line 217 "../src/core/cover-loader.vala"
			e = _inner_error0_;
#line 217 "../src/core/cover-loader.vala"
			_inner_error0_ = NULL;
#line 221 "../src/core/cover-loader.vala"
			_tmp10_ = e;
#line 221 "../src/core/cover-loader.vala"
			_tmp11_ = _tmp10_->message;
#line 221 "../src/core/cover-loader.vala"
			g_critical ("cover-loader.vala:221: Failed to load cover: %s", _tmp11_);
#line 217 "../src/core/cover-loader.vala"
			_g_error_free0 (e);
#line 1312 "cover-loader.c"
		}
		__finally0:
#line 217 "../src/core/cover-loader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 217 "../src/core/cover-loader.vala"
			_g_object_unref0 (blur_pixbuf);
#line 217 "../src/core/cover-loader.vala"
			_g_object_unref0 (overlay_pixbuf);
#line 217 "../src/core/cover-loader.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 217 "../src/core/cover-loader.vala"
			g_clear_error (&_inner_error0_);
#line 217 "../src/core/cover-loader.vala"
			return NULL;
#line 1327 "cover-loader.c"
		}
	}
#line 225 "../src/core/cover-loader.vala"
	_tmp12_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, size, size);
#line 225 "../src/core/cover-loader.vala"
	image_surface = _tmp12_;
#line 226 "../src/core/cover-loader.vala"
	_tmp13_ = image_surface;
#line 226 "../src/core/cover-loader.vala"
	_tmp14_ = cairo_create (_tmp13_);
#line 226 "../src/core/cover-loader.vala"
	cr = _tmp14_;
#line 1340 "cover-loader.c"
	{
		GdkPixbuf* _tmp15_ = NULL;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GdkPixbuf* _tmp18_;
		GdkPixbuf* _tmp19_;
		GdkPixbuf* _tmp20_;
		GdkPixbuf* _tmp21_ = NULL;
		gchar* _tmp22_;
		gchar* _tmp23_;
		GdkPixbuf* _tmp24_;
		GdkPixbuf* _tmp25_;
		GdkPixbuf* _tmp26_;
#line 229 "../src/core/cover-loader.vala"
		_tmp16_ = g_file_get_path (file);
#line 229 "../src/core/cover-loader.vala"
		_tmp17_ = _tmp16_;
#line 229 "../src/core/cover-loader.vala"
		_tmp18_ = gdk_pixbuf_new_from_file_at_scale (_tmp17_, width, height, FALSE, &_inner_error0_);
#line 229 "../src/core/cover-loader.vala"
		_tmp19_ = _tmp18_;
#line 229 "../src/core/cover-loader.vala"
		_g_free0 (_tmp17_);
#line 229 "../src/core/cover-loader.vala"
		_tmp15_ = _tmp19_;
#line 229 "../src/core/cover-loader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1368 "cover-loader.c"
			goto __catch1_g_error;
		}
#line 229 "../src/core/cover-loader.vala"
		_tmp20_ = _tmp15_;
#line 229 "../src/core/cover-loader.vala"
		_tmp15_ = NULL;
#line 229 "../src/core/cover-loader.vala"
		_g_object_unref0 (overlay_pixbuf);
#line 229 "../src/core/cover-loader.vala"
		overlay_pixbuf = _tmp20_;
#line 230 "../src/core/cover-loader.vala"
		_tmp22_ = g_file_get_path (file);
#line 230 "../src/core/cover-loader.vala"
		_tmp23_ = _tmp22_;
#line 230 "../src/core/cover-loader.vala"
		_tmp24_ = gdk_pixbuf_new_from_file_at_scale (_tmp23_, zoom_width, zoom_height, FALSE, &_inner_error0_);
#line 230 "../src/core/cover-loader.vala"
		_tmp25_ = _tmp24_;
#line 230 "../src/core/cover-loader.vala"
		_g_free0 (_tmp23_);
#line 230 "../src/core/cover-loader.vala"
		_tmp21_ = _tmp25_;
#line 230 "../src/core/cover-loader.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 230 "../src/core/cover-loader.vala"
			_g_object_unref0 (_tmp15_);
#line 1395 "cover-loader.c"
			goto __catch1_g_error;
		}
#line 230 "../src/core/cover-loader.vala"
		_tmp26_ = _tmp21_;
#line 230 "../src/core/cover-loader.vala"
		_tmp21_ = NULL;
#line 230 "../src/core/cover-loader.vala"
		_g_object_unref0 (blur_pixbuf);
#line 230 "../src/core/cover-loader.vala"
		blur_pixbuf = _tmp26_;
#line 228 "../src/core/cover-loader.vala"
		_g_object_unref0 (_tmp21_);
#line 228 "../src/core/cover-loader.vala"
		_g_object_unref0 (_tmp15_);
#line 1410 "cover-loader.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
#line 228 "../src/core/cover-loader.vala"
		e = _inner_error0_;
#line 228 "../src/core/cover-loader.vala"
		_inner_error0_ = NULL;
#line 233 "../src/core/cover-loader.vala"
		_tmp27_ = e;
#line 233 "../src/core/cover-loader.vala"
		_tmp28_ = _tmp27_->message;
#line 233 "../src/core/cover-loader.vala"
		g_critical ("cover-loader.vala:233: Failed to load cover image: %s", _tmp28_);
#line 234 "../src/core/cover-loader.vala"
		result = NULL;
#line 234 "../src/core/cover-loader.vala"
		_g_error_free0 (e);
#line 234 "../src/core/cover-loader.vala"
		_cairo_destroy0 (cr);
#line 234 "../src/core/cover-loader.vala"
		_cairo_surface_destroy0 (image_surface);
#line 234 "../src/core/cover-loader.vala"
		_g_object_unref0 (blur_pixbuf);
#line 234 "../src/core/cover-loader.vala"
		_g_object_unref0 (overlay_pixbuf);
#line 234 "../src/core/cover-loader.vala"
		return result;
#line 1442 "cover-loader.c"
	}
	__finally1:
#line 228 "../src/core/cover-loader.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 228 "../src/core/cover-loader.vala"
		_cairo_destroy0 (cr);
#line 228 "../src/core/cover-loader.vala"
		_cairo_surface_destroy0 (image_surface);
#line 228 "../src/core/cover-loader.vala"
		_g_object_unref0 (blur_pixbuf);
#line 228 "../src/core/cover-loader.vala"
		_g_object_unref0 (overlay_pixbuf);
#line 228 "../src/core/cover-loader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 228 "../src/core/cover-loader.vala"
		g_clear_error (&_inner_error0_);
#line 228 "../src/core/cover-loader.vala"
		return NULL;
#line 1461 "cover-loader.c"
	}
#line 237 "../src/core/cover-loader.vala"
	_tmp29_ = cr;
#line 237 "../src/core/cover-loader.vala"
	cairo_save (_tmp29_);
#line 239 "../src/core/cover-loader.vala"
	if (height >= width) {
#line 1469 "cover-loader.c"
		gint blur_y = 0;
		cairo_t* _tmp30_;
		GdkPixbuf* _tmp31_;
		cairo_t* _tmp34_;
		GdkPixbuf* _tmp35_;
#line 240 "../src/core/cover-loader.vala"
		blur_y = (gint) (((gdouble) (height - width)) / 2);
#line 242 "../src/core/cover-loader.vala"
		_tmp30_ = cr;
#line 242 "../src/core/cover-loader.vala"
		_tmp31_ = blur_pixbuf;
#line 242 "../src/core/cover-loader.vala"
		games_cover_loader_draw_cover_blur_rect (self, _tmp30_, _tmp31_, size, scale_factor, FALSE, 0, blur_y, overlay_x, size);
#line 245 "../src/core/cover-loader.vala"
		if (height > width) {
#line 1485 "cover-loader.c"
			cairo_t* _tmp32_;
#line 246 "../src/core/cover-loader.vala"
			_tmp32_ = cr;
#line 246 "../src/core/cover-loader.vala"
			cairo_translate (_tmp32_, (gdouble) (overlay_x + width), (gdouble) 0);
#line 1491 "cover-loader.c"
		} else {
			cairo_t* _tmp33_;
#line 248 "../src/core/cover-loader.vala"
			_tmp33_ = cr;
#line 248 "../src/core/cover-loader.vala"
			cairo_translate (_tmp33_, (gdouble) 0, (gdouble) blur_y);
#line 1498 "cover-loader.c"
		}
#line 250 "../src/core/cover-loader.vala"
		_tmp34_ = cr;
#line 250 "../src/core/cover-loader.vala"
		_tmp35_ = blur_pixbuf;
#line 250 "../src/core/cover-loader.vala"
		games_cover_loader_draw_cover_blur_rect (self, _tmp34_, _tmp35_, size, scale_factor, TRUE, overlay_x + width, blur_y, (size - width) - overlay_x, size);
#line 1506 "cover-loader.c"
	} else {
		gint blur_x = 0;
		cairo_t* _tmp36_;
		GdkPixbuf* _tmp37_;
		cairo_t* _tmp40_;
		GdkPixbuf* _tmp41_;
#line 255 "../src/core/cover-loader.vala"
		blur_x = (gint) (((gdouble) (width - height)) / 2);
#line 257 "../src/core/cover-loader.vala"
		_tmp36_ = cr;
#line 257 "../src/core/cover-loader.vala"
		_tmp37_ = blur_pixbuf;
#line 257 "../src/core/cover-loader.vala"
		games_cover_loader_draw_cover_blur_rect (self, _tmp36_, _tmp37_, size, scale_factor, FALSE, blur_x, 0, size, overlay_y);
#line 260 "../src/core/cover-loader.vala"
		if (height > width) {
#line 1523 "cover-loader.c"
			cairo_t* _tmp38_;
#line 261 "../src/core/cover-loader.vala"
			_tmp38_ = cr;
#line 261 "../src/core/cover-loader.vala"
			cairo_translate (_tmp38_, (gdouble) blur_x, (gdouble) 0);
#line 1529 "cover-loader.c"
		} else {
			cairo_t* _tmp39_;
#line 263 "../src/core/cover-loader.vala"
			_tmp39_ = cr;
#line 263 "../src/core/cover-loader.vala"
			cairo_translate (_tmp39_, (gdouble) 0, (gdouble) (overlay_y + height));
#line 1536 "cover-loader.c"
		}
#line 265 "../src/core/cover-loader.vala"
		_tmp40_ = cr;
#line 265 "../src/core/cover-loader.vala"
		_tmp41_ = blur_pixbuf;
#line 265 "../src/core/cover-loader.vala"
		games_cover_loader_draw_cover_blur_rect (self, _tmp40_, _tmp41_, size, scale_factor, TRUE, blur_x, overlay_y + height, size, (size - height) - overlay_y);
#line 1544 "cover-loader.c"
	}
#line 270 "../src/core/cover-loader.vala"
	_tmp42_ = cr;
#line 270 "../src/core/cover-loader.vala"
	cairo_restore (_tmp42_);
#line 272 "../src/core/cover-loader.vala"
	_tmp43_ = cr;
#line 272 "../src/core/cover-loader.vala"
	_tmp44_ = overlay_pixbuf;
#line 272 "../src/core/cover-loader.vala"
	gdk_cairo_set_source_pixbuf (_tmp43_, _tmp44_, (gdouble) overlay_x, (gdouble) overlay_y);
#line 273 "../src/core/cover-loader.vala"
	_tmp45_ = cr;
#line 273 "../src/core/cover-loader.vala"
	cairo_paint (_tmp45_);
#line 275 "../src/core/cover-loader.vala"
	_tmp46_ = image_surface;
#line 275 "../src/core/cover-loader.vala"
	_tmp47_ = gdk_pixbuf_get_from_surface (_tmp46_, 0, 0, size, size);
#line 275 "../src/core/cover-loader.vala"
	result = _tmp47_;
#line 275 "../src/core/cover-loader.vala"
	_cairo_destroy0 (cr);
#line 275 "../src/core/cover-loader.vala"
	_cairo_surface_destroy0 (image_surface);
#line 275 "../src/core/cover-loader.vala"
	_g_object_unref0 (blur_pixbuf);
#line 275 "../src/core/cover-loader.vala"
	_g_object_unref0 (overlay_pixbuf);
#line 275 "../src/core/cover-loader.vala"
	return result;
#line 1576 "cover-loader.c"
}

static gpointer
_games_cover_loader_cover_request_dup0 (gpointer self)
{
#line 279 "../src/core/cover-loader.vala"
	return self ? games_cover_loader_cover_request_dup (self) : NULL;
#line 1584 "cover-loader.c"
}

void
games_cover_loader_fetch_cover (GamesCoverLoader* self,
                                GamesGame* game,
                                gint scale_factor,
                                gint cover_size,
                                gint icon_size,
                                GamesCoverLoaderCoverReadyCallback cb,
                                gpointer cb_target)
{
	GAsyncQueue* _tmp0_;
	GamesGame* _tmp1_;
	GamesCoverLoaderCoverRequest _tmp2_ = {0};
	GamesCoverLoaderCoverRequest _tmp3_;
	GamesCoverLoaderCoverRequest* _tmp4_;
#line 278 "../src/core/cover-loader.vala"
	g_return_if_fail (self != NULL);
#line 278 "../src/core/cover-loader.vala"
	g_return_if_fail (game != NULL);
#line 279 "../src/core/cover-loader.vala"
	_tmp0_ = self->priv->request_queue;
#line 279 "../src/core/cover-loader.vala"
	_tmp1_ = _g_object_ref0 (game);
#line 279 "../src/core/cover-loader.vala"
	_g_object_unref0 (_tmp2_.game);
#line 279 "../src/core/cover-loader.vala"
	_tmp2_.game = _tmp1_;
#line 279 "../src/core/cover-loader.vala"
	_tmp2_.scale_factor = scale_factor;
#line 279 "../src/core/cover-loader.vala"
	_tmp2_.cover_size = cover_size;
#line 279 "../src/core/cover-loader.vala"
	_tmp2_.icon_size = icon_size;
#line 279 "../src/core/cover-loader.vala"
	_tmp2_.cb = cb;
#line 279 "../src/core/cover-loader.vala"
	_tmp2_.cb_target = cb_target;
#line 279 "../src/core/cover-loader.vala"
	_tmp3_ = _tmp2_;
#line 279 "../src/core/cover-loader.vala"
	_tmp4_ = _games_cover_loader_cover_request_dup0 (&_tmp3_);
#line 279 "../src/core/cover-loader.vala"
	g_async_queue_push (_tmp0_, _tmp4_);
#line 279 "../src/core/cover-loader.vala"
	games_cover_loader_cover_request_destroy (&_tmp3_);
#line 1631 "cover-loader.c"
}

GamesCoverLoader*
games_cover_loader_construct (GType object_type)
{
	GamesCoverLoader * self = NULL;
#line 3 "../src/core/cover-loader.vala"
	self = (GamesCoverLoader*) g_object_new (object_type, NULL);
#line 3 "../src/core/cover-loader.vala"
	return self;
#line 1642 "cover-loader.c"
}

GamesCoverLoader*
games_cover_loader_new (void)
{
#line 3 "../src/core/cover-loader.vala"
	return games_cover_loader_construct (GAMES_TYPE_COVER_LOADER);
#line 1650 "cover-loader.c"
}

static void
games_cover_loader_cover_request_copy (const GamesCoverLoaderCoverRequest* self,
                                       GamesCoverLoaderCoverRequest* dest)
{
	GamesGame* _tmp0_;
	GamesGame* _tmp1_;
	GamesCoverLoaderCoverReadyCallback _tmp2_;
	gpointer _tmp2__target;
#line 10 "../src/core/cover-loader.vala"
	_tmp0_ = (*self).game;
#line 10 "../src/core/cover-loader.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 10 "../src/core/cover-loader.vala"
	_g_object_unref0 ((*dest).game);
#line 10 "../src/core/cover-loader.vala"
	(*dest).game = _tmp1_;
#line 10 "../src/core/cover-loader.vala"
	(*dest).scale_factor = (*self).scale_factor;
#line 10 "../src/core/cover-loader.vala"
	(*dest).cover_size = (*self).cover_size;
#line 10 "../src/core/cover-loader.vala"
	(*dest).icon_size = (*self).icon_size;
#line 10 "../src/core/cover-loader.vala"
	_tmp2_ = (*self).cb;
#line 10 "../src/core/cover-loader.vala"
	_tmp2__target = (*self).cb_target;
#line 10 "../src/core/cover-loader.vala"
	(*dest).cb = _tmp2_;
#line 10 "../src/core/cover-loader.vala"
	(*dest).cb_target = _tmp2__target;
#line 1683 "cover-loader.c"
}

static void
games_cover_loader_cover_request_destroy (GamesCoverLoaderCoverRequest* self)
{
#line 11 "../src/core/cover-loader.vala"
	_g_object_unref0 ((*self).game);
#line 1691 "cover-loader.c"
}

static GamesCoverLoaderCoverRequest*
games_cover_loader_cover_request_dup (const GamesCoverLoaderCoverRequest* self)
{
	GamesCoverLoaderCoverRequest* dup;
#line 10 "../src/core/cover-loader.vala"
	dup = g_new0 (GamesCoverLoaderCoverRequest, 1);
#line 10 "../src/core/cover-loader.vala"
	games_cover_loader_cover_request_copy (self, dup);
#line 10 "../src/core/cover-loader.vala"
	return dup;
#line 1704 "cover-loader.c"
}

static void
games_cover_loader_cover_request_free (GamesCoverLoaderCoverRequest* self)
{
#line 10 "../src/core/cover-loader.vala"
	games_cover_loader_cover_request_destroy (self);
#line 10 "../src/core/cover-loader.vala"
	g_free (self);
#line 1714 "cover-loader.c"
}

static GType
games_cover_loader_cover_request_get_type_once (void)
{
	GType games_cover_loader_cover_request_type_id;
	games_cover_loader_cover_request_type_id = g_boxed_type_register_static ("GamesCoverLoaderCoverRequest", (GBoxedCopyFunc) games_cover_loader_cover_request_dup, (GBoxedFreeFunc) games_cover_loader_cover_request_free);
	return games_cover_loader_cover_request_type_id;
}

static GType
games_cover_loader_cover_request_get_type (void)
{
	static volatile gsize games_cover_loader_cover_request_type_id__once = 0;
	if (g_once_init_enter (&games_cover_loader_cover_request_type_id__once)) {
		GType games_cover_loader_cover_request_type_id;
		games_cover_loader_cover_request_type_id = games_cover_loader_cover_request_get_type_once ();
		g_once_init_leave (&games_cover_loader_cover_request_type_id__once, games_cover_loader_cover_request_type_id);
	}
	return games_cover_loader_cover_request_type_id__once;
}

static void
_games_cover_loader_cover_request_free0_ (gpointer var)
{
#line 22 "../src/core/cover-loader.vala"
	(var == NULL) ? NULL : (var = (games_cover_loader_cover_request_free (var), NULL));
#line 1742 "cover-loader.c"
}

static gpointer
_games_cover_loader_run_loader_thread_gthread_func (gpointer self)
{
	gpointer result;
#line 23 "../src/core/cover-loader.vala"
	games_cover_loader_run_loader_thread ((GamesCoverLoader*) self);
#line 1751 "cover-loader.c"
	result = NULL;
#line 23 "../src/core/cover-loader.vala"
	g_object_unref (self);
#line 23 "../src/core/cover-loader.vala"
	return result;
#line 1757 "cover-loader.c"
}

static GObject *
games_cover_loader_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GamesCoverLoader * self;
	GAsyncQueue* _tmp0_;
	GThread* _tmp1_;
#line 21 "../src/core/cover-loader.vala"
	parent_class = G_OBJECT_CLASS (games_cover_loader_parent_class);
#line 21 "../src/core/cover-loader.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 21 "../src/core/cover-loader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_COVER_LOADER, GamesCoverLoader);
#line 22 "../src/core/cover-loader.vala"
	_tmp0_ = g_async_queue_new_full (_games_cover_loader_cover_request_free0_);
#line 22 "../src/core/cover-loader.vala"
	_g_async_queue_unref0 (self->priv->request_queue);
#line 22 "../src/core/cover-loader.vala"
	self->priv->request_queue = _tmp0_;
#line 23 "../src/core/cover-loader.vala"
	_tmp1_ = g_thread_new (NULL, _games_cover_loader_run_loader_thread_gthread_func, g_object_ref (self));
#line 23 "../src/core/cover-loader.vala"
	_g_thread_unref0 (self->priv->thread);
#line 23 "../src/core/cover-loader.vala"
	self->priv->thread = _tmp1_;
#line 21 "../src/core/cover-loader.vala"
	return obj;
#line 1790 "cover-loader.c"
}

static void
games_cover_loader_class_init (GamesCoverLoaderClass * klass,
                               gpointer klass_data)
{
#line 3 "../src/core/cover-loader.vala"
	games_cover_loader_parent_class = g_type_class_peek_parent (klass);
#line 3 "../src/core/cover-loader.vala"
	g_type_class_adjust_private_offset (klass, &GamesCoverLoader_private_offset);
#line 3 "../src/core/cover-loader.vala"
	G_OBJECT_CLASS (klass)->constructor = games_cover_loader_constructor;
#line 3 "../src/core/cover-loader.vala"
	G_OBJECT_CLASS (klass)->finalize = games_cover_loader_finalize;
#line 1805 "cover-loader.c"
}

static void
games_cover_loader_instance_init (GamesCoverLoader * self,
                                  gpointer klass)
{
#line 3 "../src/core/cover-loader.vala"
	self->priv = games_cover_loader_get_instance_private (self);
#line 1814 "cover-loader.c"
}

static void
games_cover_loader_finalize (GObject * obj)
{
	GamesCoverLoader * self;
#line 3 "../src/core/cover-loader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_TYPE_COVER_LOADER, GamesCoverLoader);
#line 18 "../src/core/cover-loader.vala"
	_g_async_queue_unref0 (self->priv->request_queue);
#line 19 "../src/core/cover-loader.vala"
	_g_thread_unref0 (self->priv->thread);
#line 3 "../src/core/cover-loader.vala"
	G_OBJECT_CLASS (games_cover_loader_parent_class)->finalize (obj);
#line 1829 "cover-loader.c"
}

static GType
games_cover_loader_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesCoverLoaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_cover_loader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesCoverLoader), 0, (GInstanceInitFunc) games_cover_loader_instance_init, NULL };
	GType games_cover_loader_type_id;
	games_cover_loader_type_id = g_type_register_static (G_TYPE_OBJECT, "GamesCoverLoader", &g_define_type_info, 0);
	GamesCoverLoader_private_offset = g_type_add_instance_private (games_cover_loader_type_id, sizeof (GamesCoverLoaderPrivate));
	return games_cover_loader_type_id;
}

GType
games_cover_loader_get_type (void)
{
	static volatile gsize games_cover_loader_type_id__once = 0;
	if (g_once_init_enter (&games_cover_loader_type_id__once)) {
		GType games_cover_loader_type_id;
		games_cover_loader_type_id = games_cover_loader_get_type_once ();
		g_once_init_leave (&games_cover_loader_type_id__once, games_cover_loader_type_id);
	}
	return games_cover_loader_type_id__once;
}

